SystemOrganization addCategory: #ConfigurationOfContextS!

Object subclass: #ConfigurationOfContextS
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfContextS'!

!ConfigurationOfContextS class methodsFor: 'development support' stamp: 'tfel 4/17/2012 16:24:06.238'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfContextS class methodsFor: 'private' stamp: 'tfel 4/17/2012 16:24:06.286'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfContextS class methodsFor: 'private' stamp: 'tfel 4/17/2012 16:24:06.309'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfContextS class methodsFor: 'private' stamp: 'tfel 4/17/2012 16:24:06.333'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfContextS class methodsFor: 'metacello tool support' stamp: 'tfel 4/17/2012 16:24:06.358'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfContextS class methodsFor: 'loading' stamp: 'tfel 4/17/2012 16:24:06.381'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfContextS class methodsFor: 'loading' stamp: 'tfel 4/17/2012 16:24:06.405'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfContextS class methodsFor: 'loading' stamp: 'tfel 4/17/2012 16:24:06.43'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfContextS class methodsFor: 'accessing' stamp: 'tfel 4/17/2012 16:24:06.454'!
project

	^self new project! !

!ConfigurationOfContextS class methodsFor: 'development support' stamp: 'tfel 4/17/2012 16:24:06.262'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfContextS methodsFor: 'baselines' stamp: 'tfel 4/17/2012 16:26:09.145'!
baseline20: spec
	<version: '2.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/ContextSTrunk'.
		spec 
			package: 'ContextS2-Core';
			package: 'ContextS2-Tests' with: [spec requires: 'ContextS2-Core'].
		spec group: 'default' with: #('ContextS2-Core' 'ContextS2-Tests' ). ].
! !

!ConfigurationOfContextS methodsFor: 'symbolic versions' stamp: 'tfel 4/17/2012 16:24:06.587'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '2.0'.
! !

!ConfigurationOfContextS methodsFor: 'accessing' stamp: 'tfel 4/17/2012 16:24:06.213'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfContextS methodsFor: 'versions' stamp: 'tfel 4/17/2012 16:24:06.562'!
version20: spec
	<version: '2.0' imports: #('2.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'tfel'.
		spec timestamp: '4/17/2012 16:24'.
		spec 
			package: 'ContextS2-Core' with: 'ContextS2-Core-tfel.78';
			package: 'ContextS2-Tests' with: 'ContextS2-Tests-tfel.53'. ].
! !
